
// BBC micro:bit code pfodMenu.h and pfodMenu.cpp for Netbeans
// This cpp code needs pfodParserMicroBit support files from www.pfod.com.au

// copy this code into pfodMenu.h
// =============  start of pfodMenu.h file =============
/* ===== pfod Command for Menu_1 ====
pfodApp msg {.} --> {,<bg n><b><i><+6>~BBC micro:bit`1000~V3|!F<+9>`28~~â„ƒ`40`0~40~0~t|!C~|!A<+5>`775~P0 ~V`1023`0~3.3~0~|!D~|B<b><+6>`0~P1 is ~~Off\On~|E<+6>~Plots}
 */
/* 
 * File:   pfodMenu.h for BBC micro:bit
 */
/* Code generated by pfodDesignerV2 V2.0.2211
 * (c)2014-2016 Forward Computing and Control Pty. Ltd.
 * NSW Australia, www.forward.com.au
 * This code is not warranted to be fit for any purpose. You may only use it at your own risk.
 * This generated code may be freely used for both private and commercial use
 * Provide this copyright is maintained.
 */

#ifndef PFODMENU_H
#define PFODMENU_H
#include <stdint.h>
#include "pfodParser.h"
#include "MicroBit.h"


class pfodMenu : pfodParser {
public:
  // public vars set by parser, access and update these in your main program
  int cmd_F_var; // name the variable for ''
  int cmd_A_var; // name the variable for 'P0'
  int cmd_B_var; // name the variable for 'P1 is'  0=Off 1=On 

// plotting data variables
  int plot_1_var;
  int plot_2_var;
  // plot 3 is hidden
  unsigned long plotTime; // used in sendData in main.cpp and below
  void sendData(void); // This method is call automatically if plotInterval > 0   You can also call it from your own fiber
  
  bool isConnected(void); // set true when {.} parsed, set false when {!} parsed.
  pfodMenu(void);
  void init(MicroBit* _uBit);

private:

// plotting data variables
  int plot_1_varMin;
  float plot_1_scaling;
  float plot_1_varDisplayMin;
  int plot_2_varMin;
  float plot_2_scaling;
  float plot_2_varDisplayMin;
  // plot 3 is hidden

  void sendMainMenu();
  void sendMainMenuUpdate();
  
  static const int maxRxMsgSize; //max size of pfodCmd ALWAYS <= 255
  static const unsigned long plotInterval; // used to sendData in main.cpp
  void initGlobalVars(void);
  void createStream();
  void processCmd(); 
  static void fiber_SendData(void);
  static void pfodAppDisconnected(MicroBitEvent);
  static void pfodProcessRx(MicroBitEvent);
  static const char *vers; // the menu version no
  static pfodMenu* menuParserPtr;
};
#endif /* PFODMENU_H */
// ===============  end of pfodMenu.h file ================
